---
image: python:3.11.4

stages:
- test
- build

variables:
  POETRY_VIRTUALENVS_IN_PROJECT: 'true'

cache:
  paths:
  - .venv
  key: "${CI_COMMIT_REF_SLUG}"

default:
  before_script:
  - /usr/local/bin/python -m pip install --upgrade pip
  - pip install poetry
  - poetry check
  - poetry install --no-interaction --no-ansi --with dev
  - source .venv/bin/activate

static analysis:
  stage: test
  script:
  - pre-commit run --all-files

unit test:
  stage: test
  variables:
    COVERAGE_RCFILE: ${CI_PROJECT_DIR}/pyproject.toml
  coverage: '/TOTAL.*\s+(\d+%)$/'
  script:
  - coverage run -m pytest
  - coverage report --show-missing --fail-under=80

publish:
  stage: build
  script:
  - poetry version $CI_COMMIT_TAG
  - poetry build
  - poetry publish --username $PYPI_USERNAME --password $PYPI_PASSWORD
  only:
    variables:
    - $CI_COMMIT_TAG
